package oss_tool

import (
	"github.com/aliyun/alibabacloud-oss-go-sdk-v2/oss"
	"os"
	"testing"
)

var (
	accessKeyId     = os.Getenv("OSS_ACCESS_KEY_ID")
	accessKeySecret = os.Getenv("OSS_SECRET_ACCESS_KEY")
	region          = os.Getenv("OSS_REGION")
	client          = &ALiYunOSSClient{
		AccessKeyID:     accessKeyId,
		AccessKeySecret: accessKeySecret,
		Region:          region,
	}
)

func TestALiYunOSSClient_NewAliYunOSS(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	t.Log(client.ossClient)
}

func TestALiYunOSSClient_GetSignUrl(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	sign, err := client.GetSignUrl("", "test/upload/bizhi1.jpg", 0)
	if err != nil {
		t.Error(err)
	}
	t.Log(sign)
}

func TestALiYunOSSClient_GetSignUrlByPutObjectRequest(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	req := &oss.PutObjectRequest{}
	req.Bucket = oss.Ptr("")
	req.Key = oss.Ptr("test/upload/bizhi2.jpg")
	req.ContentType = oss.Ptr("application/octet-stream")
	sign, err := client.GetSignUrlByPutObjectRequest(req, 0)
	if err != nil {
		t.Error(err)
	}
	t.Log(sign)
}

func TestALiYunOSSClient_PutForLocalFile(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	result, err := client.PutForLocalFile("", "test/upload/bizhi2.jpg", "C:\\Users\\Administrator\\Desktop\\壁纸1.jpg")
	if err != nil {
		t.Error(err)
	}
	t.Log(result)
}

func TestALiYunOSSClient_GetObjectToFile(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	err = client.GetObjectToFile("", "test/upload/bizhi1.jpg", "D:/bizhi1.jpg")
	if err != nil {
		t.Error(err)
	} else {
		t.Log("成功")
	}
}

func TestALiYunOSSClient_GetObjectToImage(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	img, err := client.GetObjectToImage("", "test/upload/bizhi1.jpg")
	if err != nil {
		t.Error(err)
	} else {
		t.Log(img)
	}
}

func TestALiYunOSSClient_DelObject(t *testing.T) {
	err := client.NewAliYunOSS()
	if err != nil {
		t.Error(err)
	}
	err = client.DelObject("", "test/upload/bizhi2.jpg")
	if err != nil {
		t.Error(err)
	} else {
		t.Log("成功")
	}
}
